package org.greenstone.gsdl3.gs3build.classifier;

import org.greenstone.gsdl3.gs3build.doctypes.DocumentID;
import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;

public interface ClassifierInterface
{
	/**
	 *  Initialise the classifier as required...
	 */
	public void configure(String outputDir);

	/**
	 *  Classify an individual document - the document should be informed of any
	 *  classification nodes which it is assigned to, so that it can obtain knowledge
	 *  of any "parents".  These are assigned into the "classified" metadata item in
	 *  the "gsdl3" namespace...
	 */
	public void classifyDocument(DocumentID documentID, DocumentInterface document);

	public void startPass(int pass);

	public int getClassifierPasses();

	public void endPass(int pass);

	/**
	 *  Called at the end of the classification sequence - the classifier should
	 *  save its state at this point...
	 */
	public void completeClassification();
}