package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.PrintWriter;

import java.sql.*;

import org.greenstone.gsdl3.gs3build.util.XMLTools;
import org.greenstone.gsdl3.gs3build.util.GS3SQLConnection;
import org.greenstone.gsdl3.gs3build.database.*;

public class DocumentSQLWriter
{
  public DocumentSQLWriter()
  {
  }

  /**
   * Just write the document to the database, assuming that it is not already there
   */
  public boolean writeDocument(DocumentInterface document, GS3SQLConnection connection)
  {		
    // TODO: output document in METS format, with Greenstone-specific metadata
    // placed in a wrapper inside the descriptive metadata block

    // put the document into the database
    try {
    if (document.getID() != null)
      { //tag = XMLTools.addAttribute(tag, "OBJID", document.getID().toString());
	  GS3SQLInsert insert = new GS3SQLInsert("document");
	  insert.addValue("DocID", document.getID().toString());

	  System.out.println(insert.toString());
	  connection.execute(insert.toString());
      }
    } catch (Exception ex) {
	System.out.println(ex);
    }
    //    output.println(tag);
    
    // Write the structural metadata:
    //   if in "Create METS" mode:
    //     take all the documents as being in the one group, of the "physical"
    //     document; particular document plugins may extend this behaviour,
    //     which would suggest placing it in the AbstractDocument or similar
    //     class?!
    document.getDocumentMetadata().writeSQL(document, connection);

    document.getDocumentFiles().writeSQL(document, connection);

    document.getDocumentStructure().writeSQL(document, connection);

    // Write the body information
    // TODO: only output the document if there is some
    // content/formatting change between the original and
    // what greenstone actually does; if the original is
    // good, then place a marker saying "get the document
    // "from the original file"
    return true;
  }
}
