package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.*;
import java.net.*;

import org.greenstone.gsdl3.gs3build.metadata.*;
import org.greenstone.gsdl3.gs3build.util.HTTPTools;

public class HTMLRecogniser implements RecogniserInterface
{
	DocumentList listRepository;

	public HTMLRecogniser(DocumentList listRepository)
	{	this.listRepository = listRepository;
	}

	public boolean parseDocument(METSFile file)
	{
		String MIMEType = file.getMIMEType();
		if (MIMEType == null || 
			  MIMEType.equals("text/html")) {
			URL location = file.getLocation();
			return this.parseDocument(location);
		}
		return false;
	}

	public boolean parseDocument(URL url)
	{	if (url.toString().startsWith("file://")) {
			String fileName = url.toString().substring(7);
			if (fileName.endsWith(".htm") ||
				  fileName.endsWith(".html"))
		  {	System.out.println("Posting HTML Document " + fileName);

		  	HTMLDocument doc = new HTMLDocument(url);
		  	this.listRepository.addDocument(doc);
			  return true;
			}
		}
		else {
			// Get Mime type remotely, and then proceed if required
			String mimeType = HTTPTools.getMIMEType(url);

			if (mimeType == "text/html")
			{	System.out.println("Posting HTML Document " + url.toString());
		  	
				HTMLDocument doc = new HTMLDocument(url);
				this.listRepository.addDocument(doc);
				return true;
			}
		}
		return false;
	}
}