package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.*;
import java.net.*;

import org.greenstone.gsdl3.gs3build.metadata.*;

public class TextRecogniser implements RecogniserInterface
{
	DocumentList listRepository;

	public TextRecogniser(DocumentList listRepository)
	{	this.listRepository = listRepository;
	}

	public boolean parseDocument(METSFile file)
	{
		String MIMEType = file.getMIMEType();
		if (MIMEType == null || 
			  MIMEType.equals("text/plain")) {
			URL location = file.getLocation();
			return this.parseDocument(location);
		}
		return false;
	}

	public boolean parseDocument(URL url)
	{	if (url.toString().startsWith("file://")) {
			String fileName = url.toString().substring(7);

			if (fileName.endsWith(".txt") ||
		      fileName.endsWith(".text"))
			{	this.listRepository.addDocument(new TextDocument(url));
				// TODO: spawn knowledge of children too...
				System.out.println(">>> Posting text document " + fileName);
				return true;
			}
		}
		else
		{	// Check MIME type
		}
		
		return false;
	}
}