package org.greenstone.gsdl3.gs3build.metadata;

import java.io.PrintWriter;

import java.util.HashMap;
import java.util.Map;
import java.util.Iterator;

import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;

import org.greenstone.gsdl3.gs3build.util.GS3SQLConnection;

public class METSStructureSet
{	Map children;

	public METSStructureSet()
	{	this.children = new HashMap();
	}

	public void addStructure(METSStructure structure)
	{	this.children.put(structure.getID(), structure);
	}

	public METSStructure getStructure(String name)
	{	return (METSStructure) this.children.get(name);
	}

	public void addDivision(String structureName, METSDivision division)
	{	METSStructure structure = (METSStructure) this.children.get(structureName);

		if (structure != null)
		{ structure.addDivision(division);
		}
	}

	public void addSubDivision(String structureName, String divisionID, METSDivision division)
	{	METSStructure structure = (METSStructure) this.children.get(structureName);

		if (structure != null)
		{ structure.addSubDivision(divisionID, division);
		}
	}

	public METSDivision getDivision(String structureName, String divisionID)
	{	METSStructure structure = (METSStructure) this.children.get(structureName);

		if (structure != null)
		{ return structure.getDivision(divisionID);
		}
		return null;
	}

	public void write(PrintWriter writer)
	{ Iterator groups = this.children.values().iterator();

		while (groups.hasNext())
		{	METSStructure group = (METSStructure) groups.next();

			group.write(writer);
		}
	}

  public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
  { Iterator groups = this.children.values().iterator();
    
    while (groups.hasNext())
    { METSStructure group = (METSStructure) groups.next();

      group.writeSQL(document, connection);
    }
  }

}
