<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xslt="output.xsl"
  xmlns:java="http://xml.apache.org/xslt/java"
  xmlns:gsf="http://www.greenstone.org/configformat"
  extension-element-prefixes="java">
  
  <xsl:output method="xml"/>
  <xsl:namespace-alias
    stylesheet-prefix="xslt" result-prefix="xsl"/>

  <xsl:template match="format">
    <format>
      <xsl:apply-templates/>
    </format>
  </xsl:template>
  
  <xsl:template match="gsf:template">
    <xslt:template>
      <xsl:copy-of select="@*"/>
      <xsl:attribute name="priority">2</xsl:attribute> 
      <xsl:if test=".//gsf:link">
	<xslt:param name="serviceName"/>
	<xslt:param name="collName"/>
      </xsl:if>
      <xsl:apply-templates/>
    </xslt:template>
  </xsl:template>
  
  <xsl:template match="gsf:link">
    <xsl:choose>
      <xsl:when test="@type='classifier'">
	<a><xslt:attribute name='href'><xslt:value-of select='$library_name'/>?a=b&amp;rt=r&amp;s=<xslt:value-of select='$serviceName'/>&amp;c=<xslt:value-of select='$collName'/>&amp;cl=<xslt:value-of select='@nodeID'/><xslt:if test="classifierNode|documentNode">.pr</xslt:if><xslt:if test="parent::node()[@orientation='horizontal']">&amp;sib=1</xslt:if></xslt:attribute>
	  <xsl:apply-templates/>
	</a>
      </xsl:when>
      <xsl:otherwise> <!-- a document link -->
	<a><xslt:attribute name="href"><xslt:value-of select='$library_name'/>?a=d&amp;c=<xslt:value-of select='$collName'/>&amp;d=<xslt:value-of select='@nodeID'/>&amp;dt=<xslt:value-of select='@docType'/><xslt:if test="@nodeType='leaf'">&amp;sib=1</xslt:if>&amp;p.a=<xslt:value-of select="/page/pageRequest/@action"/>&amp;p.sa=<xsl:value-of select="/page/pageRequest/@subaction"/>&amp;p.s=<xslt:value-of select="$serviceName"/></xslt:attribute><xsl:apply-templates/></a>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="gsf:icon">
    <xsl:choose>
      <xsl:when test="@type='classifier'">
	<xslt:call-template name="bookshelfimg"/>
      </xsl:when>
      <xsl:otherwise>
	<xslt:apply-templates select="." mode="displayNodeIcon"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="gsf:metadata">
    <xslt:value-of disable-output-escaping="yes"><xsl:attribute name="select">metadataList/metadata[@name="<xsl:if test="@select='parent'">parent_</xsl:if><xsl:if test="@select='ancestors'">ancestors'<xsl:value-of select='@separator'/>'_</xsl:if><xsl:value-of select="@name"/>"]</xsl:attribute></xslt:value-of>
  </xsl:template>
  
  <xsl:template match="gsf:text">
    <xslt:apply-templates select="nodeContent"/>
  </xsl:template>
  
  <xsl:template match="*">
    <xsl:copy>
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>


